<?php
/**
  DELICIOUS MARKS for Website Baker
  
  Module developed for the Open Source Content Management System Website Baker (http://websitebaker.org)
  Copyright (C) 2009, Andr Herdling
  Contact me: mail(at)andreherdling.de, http://www.andreherdling.de

  LICENCE TERMS
  This module is free software. You can redistribute it and/or modify it 
  under the terms of the GNU General Public License  - version 2 or later, 
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  DISCLAIMER
  This module is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
  GNU General Public License for more details.
**/

// prevent this file from being accessed directly
if(!defined('WB_PATH')) die(header('Location: index.php'));  

// include core functions of WB 2.7 to edit the optional module CSS files (frontend.css, backend.css)
@include_once(WB_PATH .'/framework/module.functions.php');

/**
*	MODULE LANGUAGE SUPPORT IS INTRODUCED WITH THE LINES BELOW
*	NOTE: IF YOU ADD LANGUAGE SUPPORT TO YOUR MODULE, MAKE SURE THAT THE DEFAULT LANGUAGE
*	EN.. ENGLISH IS AVAILABLE IN ANY CASE
*/
// check if module language file exists for the language set by the user (e.g. DE, EN)
if(!file_exists(WB_PATH .'/modules/deliciousmarks/languages/' .LANGUAGE .'.php')) {
	// no module language file exists for the language set by the user, include default module language file EN.php
	require_once(WB_PATH .'/modules/deliciousmarks/languages/EN.php');
} else {
	// a module language file exists for the language defined by the user, load it
		require_once(WB_PATH .'/modules/deliciousmarks/languages/' .LANGUAGE .'.php');
}

/**
*	INLCUDE BACKEND.CSS INTO THE HTML BODY OF THE PAGE IF WB < 2.6.6
*	NOTE: THIS WAY MODULES BECOME DOWNWARD COMPATIBLE WITH OLDER WB RELEASES
*/
// check if backend.css file needs to be included into the <body></body> of modify.php
if(!method_exists($admin, 'register_backend_modfiles') && file_exists(WB_PATH .'/modules/deliciousmarks/backend.css')) {
	echo '<style type="text/css">';
	include(WB_PATH .'/modules/deliciousmarks/backend.css');
	echo "\n</style>\n";
}

/**
*	THE FUNCTIONS AND SETTINGS OF YOUR MODULE IN THE WB BACKEND ARE DEFINED BELOW THIS LINE HERE
*
*	The code below makes extracts the output text of the current displayed page from the module
*	DB-table. If the value is empty, the default text: Hello world is used as default.
*	A HTML form is added to the modify.php file. The form provides some text read from the module
*	language file, a text field which stores the Hello world output string and two buttons: 
*	SAVE and CANCEL. In addition, two hidden fields are used to pass over the PAGE_ID and
*	SECTION_ID of the current page to the save.php page, which is invoked when the SAVE button is pressed.
*	The caption of the buttons SAVE and CANCEL is taken from the global WB lanuage file /languages/XX.php.
*	This allows that the text is shown in the language the user has choosen.
*
*	Some CSS defininitions are used to demonstrate the usage of the external backend.css file.
*	A dummy Javascript function call is added at the end of the script. The function itself is defined in
*	the modules backend.js file loaded automatically by Website Baker.
*
*	NOTE: A CANCEL BUTTON SHOULD ALWAYS BE PROVIDED, WHICH REDIRECTS THE USER TO THE BACKEND->PAGES PANEL
*
*	KEEP IN MIND:
*	All user inputs should be treated as dangerous. You need to apply the required measures to
*	prevent that harmful code is added to the MySQL database or executed by PHP. 
*	Always think about filtering HTML/CSS/Javascript code from the user input. 
*
*	Some aspects on security:
*	Tags like <strong> can be used to deface your layout (<strong style="font-size:200px">some text</strong>)
*	Text fields can also be used for Javascript hacks: <script language="javascript">alert("You can be hacked!!")</script>
* To prevent SQL-injection, escape special characters before writting to the database. Use WB function add_slashes() 
* when dealing with data from POST, GET, COOKIES to prevent double quoting if magic_quotes is enabled in your php.ini.
* 
*	Make use of: strip_tags, add_slashes, or htmlspecialchars to prevent such kind of things
*/
// obtain data from module DB-table of the current displayed page (unique page defined via section_id)
$sql_result = $database->query("SELECT * FROM `" .TABLE_PREFIX ."mod_deliciousmarks` WHERE `section_id` = '$section_id'");

// store all results (fields) in the array $sql_row
$sql_row = $sql_result->fetchRow();



// check if the DB-Field delicious_username contains a value, if not use EXAMPLE as default value.
if ($sql_row['delicious_username'] == '') {
	$sql_row['delicious_username'] = 'YourDeliciousUsername'; 
} else {
	// Note: before displaying a string in a text field, one needs to convert special characters into entities.
	// Characters like " do not show up in text fields if not converted to entities.
	// This also prevents that embedded Javascript/PHP/HTML tags are parsed by the browser.
	$sql_row['delicious_username'] = htmlspecialchars($sql_row['delicious_username']);
}




//in order to show the correct selection in the drop-down-menue, we check the content
//of the according db-field an declare a special indicator
$entries5='';  //reset if set before
$entries10=''; //reset if set before
$entries15=''; //reset if set before
$entries20=''; //reset if set before
$entries30=''; //reset if set before
$entries40=''; //reset if set before
$entries50=''; //reset if set before
$entries75=''; //reset if set before
$entries100=''; //reset if set before

switch ($sql_row['delicious_entries']) {
case 5:
    $entries5 = 'selected="selected"';
    break;
case 10:
    $entries10 = 'selected="selected"';
    break;
case 15:
    $entries15 = 'selected="selected"';
    break;
case 20:
    $entries20 = 'selected="selected"';
    break;
case 30:
    $entries30 = 'selected="selected"';
    break;
case 40:
    $entries40 = 'selected="selected"';
    break;
case 50:
    $entries50 = 'selected="selected"';
    break;
case 75:
    $entries75 = 'selected="selected"';
    break;
case 99:
    $entries100 = 'selected="selected"';
    break;

}




//in order to set the radio-buttons checked or unchecked, we check the content
//of the according db-field an declare a special indicator
if ($sql_row['utf8decode_flag'] == '' OR $sql_row['utf8decode_flag'] == 0) {
        $decode_yes ='';
        $decode_no  ='checked="checked"';
} else {
        $decode_yes ='checked="checked"';
        $decode_no  ='';
};


//in order to show the correct selection in the drop-down-menue, we check the content
//of the according db-field an declare a special indicator
$cache0='';  //reset if set before
$cache15=''; //reset if set before
$cache30=''; //reset if set before
$cache60=''; //reset if set before

switch ($sql_row['cachecontrol']) {
case 0:
    $cache0 = 'selected="selected"';
    break;
case 15:
    $cache15 = 'selected="selected"';
    break;
case 30:
    $cache30 = 'selected="selected"';
    break;
case 60:
    $cache60 = 'selected="selected"';
    break;
}



	// write out heading
	echo '<h2>' .$MOD_DELICIOUSMARKS['TXT_HEADING_B'] .'</h2>';

	// include the button to edit the optional module CSS files (function added with WB 2.7)
	// Note: CSS styles for the button are defined in backend.css (div class="mod_moduledirectory_edit_css")
	// Remember to replace the string helloworld below with the module directory of your module
	// Place this call outside of any <form></form> construct!!!
	if(function_exists('edit_module_css')) {
		edit_module_css('deliciousmarks');
	}

	// create the form with text outputs and buttons below using mixed HTML and PHP code
	?>
	<form name="edit" action="<?php echo WB_URL; ?>/modules/deliciousmarks/save.php" method="post" style="margin: 0;">
		<input type="hidden" name="page_id" value="<?php echo $page_id; ?>">
		<input type="hidden" name="section_id" value="<?php echo $section_id; ?>">

	
		<table class="mod_deliciousmarks_table_b" cellpadding="0" cellspacing="0" border="0" width="100%">
			<tr>
				<td><?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_USERNAME_B']; ?>:</td>
				<td><input name="delicious_username" type="text" value="<?php echo $sql_row['delicious_username']; ?>" style="width: 200px;"></td>
			</tr>
			<tr>
				<td><?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_ENTRIES_B']; ?>:</td>
				<td>
					<select name="delicious_entries" id="delicious_entries">
                                                <option value="5" <?php echo $entries5 ?>>5</option>
                                                <option value="10" <?php echo $entries10 ?>>10</option>
						<option value="15" <?php echo $entries15 ?>>15</option>
						<option value="20" <?php echo $entries20 ?>>20</option>
						<option value="30" <?php echo $entries30 ?>>30</option>
						<option value="40" <?php echo $entries40 ?>>40</option>
						<option value="50" <?php echo $entries50 ?>>50</option>
						<option value="75" <?php echo $entries75 ?>>75</option>
						<option value="99" <?php echo $entries100 ?>>100</option>
                                        </select>
				</td>
			</tr>
                        <tr>
				<td><?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_CACHE_B']; ?>:</td>
				<td>
                                        <select name="cachecontrol" id="cachecontrol">
                                                <option value="0" <?php echo $cache0 ?>><?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_CACHE_0_B']; ?></option>
                                                <option value="15" <?php echo $cache15 ?>><?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_CACHE_15_B']; ?></option>
                                                <option value="30" <?php echo $cache30 ?>><?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_CACHE_30_B']; ?></option>
                                                <option value="60" <?php echo $cache60 ?>><?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_CACHE_60_B']; ?></option>
                                        </select>
                                        <acronym title="<?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_CACHE_INF_B']; ?>"><a href="#" onclick=
"alert('<?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_CACHE_INF_B']; ?>')" >[?]</a></acronym>
                                </td>
			</tr>
                        <tr>
				<td><?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_DECODE_B']; ?></td>
				<td><input type="radio" name="utf8decode_flag" id="utf8decode_flag" value="0" <?php echo $decode_no; ?> /> <?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_DECODE_N_B']; ?> <input type="radio" name="utf8decode_flag" id="utf8decode_flag" value="1"  <?php echo $decode_yes; ?> /> <?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_DECODE_Y_B']; ?>
                                <acronym title="<?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_DECODE_INF_B']; ?>"><a href="#" onclick=
"alert('<?php echo $MOD_DELICIOUSMARKS['TXT_INPUT_DECODE_INF_B']; ?>')" >[?]</a></acronym>
                                </td>
			</tr>
		</table>



		<table cellpadding="0" cellspacing="0" border="0" width="100%">
		<tr>
			<td align="left">
				<input name="save" type="submit" value="<?php echo $TEXT['SAVE']; ?>" style="width: 100px; margin-top: 5px;"></form>
			</td>
			<td align="right">
				<input type="button" value="<?php echo $TEXT['CANCEL']; ?>" onclick="javascript: window.location = '<?php echo ADMIN_URL; ?>/pages/index.php'; return false;" style="width: 100px; margin-top: 5px;" />
			</td>
		</tr>
	</table>

