<?php
/**
  DELICIOUS MARKS for Website Baker
  
  Module developed for the Open Source Content Management System Website Baker (http://websitebaker.org)
  Copyright (C) 2009, Andr Herdling
  Contact me: mail(at)andreherdling.de, http://www.andreherdling.de

  LICENCE TERMS
  This module is free software. You can redistribute it and/or modify it 
  under the terms of the GNU General Public License  - version 2 or later, 
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  DISCLAIMER
  This module is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
  GNU General Public License for more details.
**/

// prevent this file from being accessed directly
if(!defined('WB_PATH')) die(header('Location: index.php'));  

/**
*	MODULE LANGUAGE SUPPORT IS INTRODUCED WITH THE LINES BELOW
*	NOTE: IF YOU ADD LANGUAGE SUPPORT TO YOUR MODULE, MAKE SURE THAT THE DEFAULT LANGUAGE
*	EN.. ENGLISH IS AVAILABLE IN ANY CASE
*/
// check if module language file exists for the language set by the user (e.g. DE, EN)
if(!file_exists(WB_PATH .'/modules/deliciousmarks/languages/' .LANGUAGE .'.php')) {
	// no module language file exists for the language set by the user, include default module language file EN.php
	require_once(WB_PATH .'/modules/deliciousmarks/languages/EN.php');
} else {
	// a module language file exists for the language defined by the user, load it
		require_once(WB_PATH .'/modules/deliciousmarks/languages/' .LANGUAGE .'.php');
}

/**
*	INLCUDE FRONTEND.CSS INTO THE HTML BODY OF THE PAGE IF WB < 2.6.7 OR REGISTER_MODFILES FUNCTION
* IN THE INDEX.PHP OF YOUR TEMPLATE IS NOT USED
*	NOTE: THIS WAY MODULES BECOME DOWNWARD COMPATIBLE WITH OLDER WB RELEASES
*/
// check if frontend.css file needs to be included into the <body></body> of view.php
if((!function_exists('register_frontend_modfiles') || !defined('MOD_FRONTEND_CSS_REGISTERED')) && 
	file_exists(WB_PATH .'/modules/deliciousmarks/frontend.css')) {
	echo '<style type="text/css">';
             // ### SPECIAL CORRECTIONS FOR WB < 2.6.7 ## Makes relative CSS notations absolute
             // ### andreherdling.de
             //--we read the content of the frontend.css into $mod_wbtweets_csscontent
             $mod_deliciousmarks_csscontent=file_get_contents(WB_PATH .'/modules/deliciousmarks/frontend.css');
             //--now we correct the markup for background-images to get relative notation of diectories working
             //---at first we set up the search- and replace-strings
             $mod_deliciousmarks_csssearchstring='background-image: url(';
             $mod_deliciousmarks_cssreplacestring='background-image: url('.WB_URL .'/modules/deliciousmarks/';
             //--now we replace relative notation with absolute notation
             $mod_deliciousmarks_csscontent=str_replace($mod_deliciousmarks_csssearchstring, $mod_deliciousmarks_cssreplacestring, $mod_deliciousmarks_csscontent);
             // now the notation is correct --- start output now
             echo $mod_deliciousmarks_csscontent;
        echo "\n</style>\n";
} 

/**
*	THE FUNCTIONS AND SETTINGS OF YOUR MODULE IN THE WB FRONTED ARE DEFINED BELOW THIS LINE HERE
*
*	The code below extracts the text stored in the database, removes the contained slashes and
*	outputs the clean text to the view.php. In addition the modification data/time is written out.
*	The modification date is stored as timestamp and converted into human readable format via the
*	language file. This way all outputs can be customised depending on the language.
*
*	Some CSS defininitions are used to demonstrate the usage of the external frontend.css file.
*	A dummy Javascript function call is added at the end of the script. The function itself is defined in
*	the modules frontend.js file loaded automatically by Website Baker.
*
*	KEEP IN MIND:
*	All user inputs should be treated as dangerous. You need to apply the required measures to
*	prevent that harmful code is added to the MySQL database or executed by PHP. 
*	Always think about filtering HTML/CSS/Javascript code from the user input. 
*
*	Some aspects on security:
*	Tags like <strong> can be used to deface your layout (<strong style="font-size:200px">some text</strong>)
*	Text fields can also be used for Javascript hacks: <script language="javascript">alert("You can be hacked!!")</script>
* To prevent SQL-injection, escape special characters before writting to the database. Use WB function add_slashes() 
* when dealing with data from POST, GET, COOKIES to prevent double quoting if magic_quotes is enabled in your php.ini.
*
*	Make use of: strip_tags, add_slashes, or htmlspecialchars to prevent such kind of things
*/

// obtain data from module DB-table of the current displayed page (unique page defined via section_id)
$sql_result = $database->query("SELECT * FROM `".TABLE_PREFIX."mod_deliciousmarks` WHERE `section_id` = '$section_id'");

// check if query was sucessfull
if($sql_result->numRows() > 0) {
	// store all results (fields) in the array $sql_row
	$sql_row = $sql_result->fetchRow();

	
	$delicious_username = $sql_row['delicious_username'];
	$delicious_entries = $sql_row['delicious_entries'];
        $utf8decode_flag = $sql_row['utf8decode_flag'];
        $cachecontrol = $sql_row['cachecontrol'];

	// extract modification date/time (convert timestamp into human readable format using format string in language file)
	$last_modified = date($MOD_DELICIOUSMARKS['DATE_FORMAT_F'], $sql_row['modified_when']);
} else {
	$delicious_username = '';
	$delicious_entries = '';
	$last_modified = '';
}

//handle the entries-special (99 in DB means 100 entries)
if ($delicious_entries==99) {$delicious_entries=100;};


## LOAD REQUIRED FILES ##

//Loading SimplePie RSS-Parser (simplepie.org)
require_once(WB_PATH .'/modules/deliciousmarks/simplepie/simplepie.php');

//Loading SimplePie-Addon for Delicious
require_once(WB_PATH .'/modules/deliciousmarks/addon/delicious.php');

//Loading Module-Info-File (contains RSS-Generator-URL of Delicious)
require_once(WB_PATH .'/modules/deliciousmarks/info.php');



## SETTING UP SIMPLEPIE ##

//generate complete feed url
$delicious_feed_url = $deliciousmarks_feed_gen.$delicious_username.'?count='.$delicious_entries;

// We'll process this feed with all of the default options.
$deliciousfeed = new SimplePie();
$deliciousfeed->set_feed_url($delicious_feed_url);
$deliciousfeed->set_cache_location(WB_PATH.'/modules/wbtweets/cache');

//caching on or off? if on, set duration
if($cachecontrol == 0 OR $cachecontrol == '') {
        $deliciousfeed->enable_cache(false);
    } else {
        $deliciousfeed->enable_cache(true);
        $deliciousfeed->set_cache_duration(60*$cachecontrol);
    };

//initialize
$deliciousfeed->init();
 

// Change output encoding to isi 8859-1 if nescessary
if($utf8decode_flag !=0) {
	$deliciousfeed->set_output_encoding('iso-8859-1');	
};
$deliciousfeed->handle_content_type(); //if not changed --> uft-8




//if configured, begin output
if($delicious_username != '' AND $delicious_entries != '') {
	
	// output the page heading defined in the language file
	echo '<h2>'.htmlspecialchars(strip_tags($delicious_entries)).' '.$MOD_DELICIOUSMARKS['TXT_HEADING_F'].' '.htmlspecialchars(strip_tags($delicious_username)).'</h2>';

	
	
	
	//-START-Looping through entries (PHP/HTML Mixed Mode)
	?>
	<div class="mod_deliciousmarks_main">
		<ul class="mod_deliciousmarks_menue">
			<li><a class="mod_deliciousmarks_page" href="<?php echo $deliciousfeed->get_permalink(); ?>" title="<?php echo $MOD_DELICIOUSMARKS['TXT_DESC_SHOWALL'] ?>"><?php echo $MOD_DELICIOUSMARKS['TXT_DESC_SHOWALL'] ?></a></li>
			<li><a class="mod_deliciousmarks_subscribe" href="<?php echo $delicious_feed_url; ?>" title="<?php echo $MOD_DELICIOUSMARKS['TXT_DESC_SUBSCRIBE'] ?>"><?php echo $MOD_DELICIOUSMARKS['TXT_DESC_SUBSCRIBE'] ?></a></li>
		</ul>
	
		<?php
			/*
			Here, we'll loop through all of the items in the feed, and $item represents the current item in the loop.
			*/
			foreach ($deliciousfeed->get_items() as $item):
		?>
		
		<div class="mod_deliciousmarks_item">
			<h3><a href="<?php echo $item->get_permalink(); ?>"><?php echo $item->get_title(); ?></a></h3>
			<p><?php echo $item->get_description(); ?></p>
                        
                            <ul>
                                <?php
                        
                                foreach ($item->get_categories() as $category){
                                    echo '<li class="mod_deliciousmarks_category"><a href="'.$deliciousfeed->get_permalink().'/'.$category->term.'">'.$category->term.'</a></li>';
                                }
                            
                                ?>
                            </ul>
                        
                        <p class="mod_deliciousmarks_postedon"><?php echo $MOD_DELICIOUSMARKS['TXT_DESC_POSTED'].' '.$item->get_date($MOD_DELICIOUSMARKS['DATE_FORMAT_F']) ?></p>
		</div>
		
		<?php endforeach; ?>
	
	
	
		<ul class="mod_deliciousmarks_menue">
			<li><a class="mod_deliciousmarks_page" href="<?php echo $deliciousfeed->get_permalink(); ?>" title="<?php echo $MOD_DELICIOUSMARKS['TXT_DESC_SHOWALL'] ?>"><?php echo $MOD_DELICIOUSMARKS['TXT_DESC_SHOWALL'] ?></a></li>
			<li><a class="mod_deliciousmarks_subscribe" href="<?php echo $delicious_feed_url; ?>" title="<?php echo $MOD_DELICIOUSMARKS['TXT_DESC_SUBSCRIBE'] ?>"><?php echo $MOD_DELICIOUSMARKS['TXT_DESC_SUBSCRIBE'] ?></a></li>
		</ul>
	</div>
	<?php
	//-END-Looping through entries (PHP/HTML Mixed Mode)
	
	
	

} else { 
	// no database entry found show a warning
	echo '<p class="mod_wbtweets_warning_f">' .$MOD_DELICIOUSMARKS['TXT_ERROR_F'] .'</p>'; 
}


?>